
#include "types.h"
#include "graphics.h"
#include "sega.h"
#include "gui.h"
#include "os.h"


void ggDrawCode(u16 idx, u16 selector, u16 x, u16 y, u16 sel);
void ggEnterPar(u16 idx);
void ggEnterGg(u16 idx);
void intToGG(u32 addr, u16 val, u8 *gg);
void ggToInt(u8 *gg, u32 *addr, u16 *data);

const u8 sort_table[40] = {32, 33, 34, 35, 36, 37, 38, 39, 8, 9, 10, 11, 12, 13, 14, 15, 0, 1, 2, 3, 4, 5, 6, 7, 27, 28, 29, 30, 31, 24, 25, 26, 16, 17, 18, 19, 20, 21, 22, 23};
const u8 gg_chars[] = "ABCDEFGHJKLMNPRSTVWXYZ0123456789";

u16 ggChets() {

    u16 i;
    u16 selector = 0;
    //gCleanPlan(1, 1);
    u16 cheats_num = sizeof ( os_cfg->gam_cfg.gg_dat) / 2;
    u16 w = 22;
    u16 h = cheats_num;
    u16 x = (40 - w) / 2;
    u16 y = (28 - h) / 2;
    u16 sub_select = 0;
    //u16 first_tick = 1;
    u16 full_repaint = 1;
    u16 save = 0;
    u32 old_addr;
    u32 old_dat;




    for (;;) {



        if (full_repaint) {
            gLockRepaint(1);
            gRepairScreen();
            guiDrawWin("Cheats Menu", x - 1, y - 1, w + 2, h + 2);
            gSelectPalette(3);
            gSelectPlan(APLAN);
            gDrawString("GG", 9, y - 2);
            gDrawString("PAR", 28, y - 2);
            full_repaint = 0;
            gLockRepaint(0);
        }

        for (i = 0; i < cheats_num; i++) {
            if (i == selector) {
                gSelectPalette(2);
            } else {
                gSelectPalette(1);
            }

            ggDrawCode(i, selector, x, i + y, sub_select);
        }

        while (joy != 0);
        while (joy == 0);

        if ((joy & BUTTON_A)) {

            old_addr = os_cfg->gam_cfg.gg_addr[selector];
            old_dat = os_cfg->gam_cfg.gg_dat[selector];

            if (sub_select) {
                ggEnterPar(selector);
            } else {
                ggEnterGg(selector);
            }

            //os_cfg->gam_cfg.gg_addr[selector] &= ~1;

            if (old_addr != os_cfg->gam_cfg.gg_addr[selector] || old_dat != os_cfg->gam_cfg.gg_dat[selector]) {
                save = 1;
                os_cfg->gam_cfg.gg_state[selector] = 1;
            }

            if (os_cfg->gam_cfg.gg_addr[selector] > 0x400000)os_cfg->gam_cfg.gg_state[selector] = 0;

            full_repaint = 1;
            continue;
        }

        if ((joy & BUTTON_C)) {
            if (os_cfg->gam_cfg.gg_addr[selector] > 0x400000) {
                os_cfg->gam_cfg.gg_state[selector] = 0;
                continue;
            }
            if (os_cfg->gam_cfg.gg_addr[selector] == 0 && os_cfg->gam_cfg.gg_dat[selector] == 0)continue;
            os_cfg->gam_cfg.gg_state[selector] = os_cfg->gam_cfg.gg_state[selector] ? 0 : 1;
            save = 1;

            continue;
        }

        if ((joy & BUTTON_B)) { 

            if (save) {
                return osSaveConfig();
            } else {
                return 0;
            }

        }

        if ((joy & BUTTON_UP)) {
            selector = selector == 0 ? cheats_num - 1 : selector - 1;
            continue;
        }

        if ((joy & BUTTON_DOWN)) {
            selector++;
            selector %= cheats_num;
            continue;
        }

        if ((joy & BUTTON_LEFT) || (joy & BUTTON_RIGHT)) {
            sub_select++;
            sub_select &= 1;
            continue;
        }



    }
    return 0;
}

void ggDrawCode(u16 idx, u16 selector, u16 x, u16 y, u16 sel) {


    u32 addr = os_cfg->gam_cfg.gg_addr[idx];
    u16 val = os_cfg->gam_cfg.gg_dat[idx];
    u16 state = os_cfg->gam_cfg.gg_state[idx];

    if (selector == idx && !sel) {
        gSelectPalette(2);

    } else {

        if ((addr == 0 && val == 0) || !state) {
            gSelectPalette(0);
        } else {
            gSelectPalette(1);
        }
    }
    u16 i;
    u8 gg_code[8];


    if (addr == 0 && val == 0) {
        gDrawString("XXXX-XXXX", x, y);
    } else {
        gDrawString("", x, y);
        intToGG(addr, val, gg_code);

        for (i = 0; i < 4; i++) {
            gAppendChar(gg_code[i]);
        }
        gAppendString("-");
        for (i = 0; i < 4; i++) {
            gAppendChar(gg_code[i + 4]);
        }
    }


    gAppendString("  ");

    if (selector == idx && sel) {
        gSelectPalette(2);
    } else {
        if ((addr == 0 && val == 0) || !state) {
            gSelectPalette(0);
        } else {
            gSelectPalette(1);
        }
    }

    if (addr == 0 && val == 0) {
        gAppendString("XXXXXX:XXXX");
    } else {
        gAppendHex16(addr >> 8);
        gAppendHex8(addr & 0xff);
        gAppendString(":");
        gAppendHex16(val);
    }

}

void ggEnterPar(u16 idx) {

    u16 w = 11;
    u16 h = 10;
    u16 x = (40 - w) / 2;
    u16 y = (28 - h) / 2;
    u16 char_x = (40 - 8) / 2;
    u16 selector = 0;
    u16 selector_x = 0;
    u16 selector_y = 0;
    u16 str;
    u16 i;
    u32 addr;
    u16 val;
    u64 code = 0;
    u32 dig_sel = 0;

    code = os_cfg->gam_cfg.gg_addr[idx];
    code <<= 16;
    code |= os_cfg->gam_cfg.gg_dat[idx];

    gLockRepaint(1);
    gRepairScreen();
    guiDrawWin("Par code", x - 1, y - 1, w + 2, h + 2);
    gLockRepaint(0);


    for (;;) {

        selector = selector_x + selector_y * 4;

        for (i = 0; i < 16; i++) {

            if (i == selector) {
                gSelectPalette(2);
            } else {
                gSelectPalette(1);
            }

            str = (i < 10 ? (i + '0') : i + 0x37) << 8;
            gDrawString((u8*) & str, char_x + i % 4 * 2, y + i / 4 * 2 + 3);

        }

        addr = code >> 16;
        val = code & 0xffff;

        gSelectPalette(1);
        gDrawHex16(addr >> 8, x, y);
        gAppendHex8(addr & 0xff);
        gAppendString(":");
        gAppendHex16(val);

        gSelectPalette(2);

        /*
                i = (code >> (36 - dig_sel * 4)) & 15;
                str = (i < 10 ? (i + '0') : i + 0x37) << 8;
                gDrawString((u8 *) & str, x + (dig_sel < 6 ? dig_sel : dig_sel + 1), y);
         */


        while (joy != 0) {
            guiDrawCursor("-", x + (dig_sel < 6 ? dig_sel : dig_sel + 1), y + 1);
        }
        while (joy == 0) {
            guiDrawCursor("-", x + (dig_sel < 6 ? dig_sel : dig_sel + 1), y + 1);
        }

        gFillRect(0, x, y + 1, w, 1);

        if ((joy & BUTTON_A)) {

            code &= ~((u64) 15 << (36 - dig_sel * 4));
            code |= ((u64) selector << (36 - dig_sel * 4));

            dig_sel++;
            if (dig_sel >= 10)break;
        }

        if ((joy & BUTTON_B)) {
            if (dig_sel != 0)dig_sel--;
        }

        if ((joy & BUTTON_C)) {
            if (dig_sel < 9)dig_sel++;
        }

        if ((joy & BUTTON_UP)) {
            selector_y = selector_y == 0 ? 3 : selector_y - 1;
        }

        if ((joy & BUTTON_DOWN)) {
            selector_y++;
            selector_y %= 4;
        }

        if ((joy & BUTTON_START)) {
            break;
        }

        if ((joy & BUTTON_LEFT)) {
            selector_x = selector_x == 0 ? 3 : selector_x - 1;
        }

        if ((joy & BUTTON_RIGHT)) {

            selector_x++;
            selector_x %= 4;
        }

    }



    addr = code >> 16;
    val = code & 0xffff;

    os_cfg->gam_cfg.gg_addr[idx] = addr;
    os_cfg->gam_cfg.gg_dat[idx] = val;

}

void intToGG(u32 addr, u16 val, u8 *gg) {

    u16 i;
    u64 sorted_val = 0;
    u16 bit;



    for (i = 0; i < 40; i++) {


        bit = 39 - sort_table[i];

        if (bit < 16) {
            if ((val & (1 << bit)))sorted_val |= (u64) 1 << (39 - i);
        } else {
            bit -= 16;
            if ((addr & (1 << bit)))sorted_val |= (u64) 1 << (39 - i);
        }

        //bit = code >> (39 - sort_table[i]) & 1;
        //if (bit)sorted_val |= (u64) 1 << (39 - i);

    }

    for (i = 0; i < 8; i++) {
        gg[i] = gg_chars[(sorted_val >> (35 - i * 5)) & 31];
    }
}

void ggEnterGg(u16 idx) {

    u16 w = 15;
    u16 h = 10;
    u16 x = (40 - w) / 2;
    u16 y = (28 - h) / 2;
    u16 char_x = (40 - 16) / 2;
    u16 code_x = (40 - 9) / 2;
    u16 selector = 0;
    u16 selector_x = 0;
    u16 selector_y = 0;
    u16 str;
    u16 i;
    u32 addr = os_cfg->gam_cfg.gg_addr[idx];
    u16 val = os_cfg->gam_cfg.gg_dat[idx];
    u32 dig_sel = 0;
    u8 code[8];


    intToGG(addr, val, code);

    gLockRepaint(1);
    gRepairScreen();
    guiDrawWin("GG code", x - 1, y - 1, w + 2, h + 2);
    gLockRepaint(0);


    for (;;) {

        selector = selector_x + selector_y * 8;

        for (i = 0; i < 32; i++) {

            if (i == selector) {
                gSelectPalette(2);
            } else {
                gSelectPalette(1);
            }

            str = gg_chars[i] << 8;
            gDrawString((u8*) & str, char_x + i % 8 * 2, y + i / 8 * 2 + 3);

        }


        /*
        addr = code >> 16;
        val = code & 0xffff;*/

        gSelectPalette(1);
        gDrawString("", code_x, y);
        for (i = 0; i < 4; i++) {
            gAppendChar(code[i]);
        }
        gAppendString(":");
        for (i = 0; i < 4; i++) {
            gAppendChar(code[i + 4]);
        }


        gSelectPalette(2);

        /*
                // i = (code >> (36 - dig_sel * 4)) & 15;
                str = gg_chars[selector] << 8;
                gDrawString((u8*) & str, code_x + (dig_sel < 4 ? dig_sel : dig_sel + 1), y);

         */

        while (joy != 0) {
            guiDrawCursor("-", code_x + (dig_sel < 4 ? dig_sel : dig_sel + 1), y + 1);
        }
        while (joy == 0) {
            guiDrawCursor("-", code_x + (dig_sel < 4 ? dig_sel : dig_sel + 1), y + 1);
        }

        gFillRect(0, x, y + 1, w, 1);

        if ((joy & BUTTON_A)) {

            code[dig_sel] = gg_chars[selector];
            /*
            code &= ~((u64) 15 << (36 - dig_sel * 4));
            code |= ((u64) selector << (36 - dig_sel * 4));
             */
            dig_sel++;
            if (dig_sel >= 8)break;
        }

        if ((joy & BUTTON_B)) {
            if (dig_sel != 0)dig_sel--;
        }

        if ((joy & BUTTON_C)) {
            if (dig_sel < 7)dig_sel++;
        }

        if ((joy & BUTTON_UP)) {
            selector_y = selector_y == 0 ? 3 : selector_y - 1;
        }

        if ((joy & BUTTON_DOWN)) {
            selector_y++;
            selector_y %= 4;
        }

        if ((joy & BUTTON_START)) {
            break;
        }

        if ((joy & BUTTON_LEFT)) {
            selector_x = selector_x == 0 ? 7 : selector_x - 1;
        }

        if ((joy & BUTTON_RIGHT)) {

            selector_x++;
            selector_x %= 8;
        }

    }


    ggToInt(code, &addr, &val);

    os_cfg->gam_cfg.gg_addr[idx] = addr;
    os_cfg->gam_cfg.gg_dat[idx] = val;

}

u8 ggCharToInt(char ch) {
    u8 i;
    for (i = 0; i < sizeof (gg_chars); i++) {
        if (ch == gg_chars[i]) return i;
    }
    return 0;
}

void sortGGBits(u32 val_hi, u32 val_lo, u32 *addr, u16 *data) {

    //UInt64 sorted_val = 0;
    u8 i;
    u8 bit;
    u8 bit_idx;
    *addr = 0;
    *data = 0;

    u32 out_val_lo = 0;
    u32 out_val_hi = 0;


    for (i = 0; i < 40; i++) {
        bit_idx = (39 - i);

        if (bit_idx < 20) {
            bit = (val_hi >> (39 - i)) & 1;
        } else {
            bit = (val_lo >> (19 - i)) & 1;
        }

        bit_idx = (39 - sort_table[i]);

        if (bit_idx < 20) {
            out_val_hi |= bit << bit_idx;
        } else {
            bit_idx -= 20;

            out_val_lo |= bit << bit_idx;
        }

        //bit = (val >> (39 - i)) & 1;
        //sorted_val |= bit << (39 - sort_table[i]);
    }

    *addr = out_val_hi << 4;
    *addr |= out_val_lo >> 16;
    *data = out_val_lo;

    *addr = out_val_lo << 4;
    *addr |= out_val_hi >> 16;
    *data = out_val_hi;

}

void ggToInt(u8 *gg, u32 *addr, u16 *data) {

    u32 val_lo = 0;
    u32 val_hi = 0;
    u8 i;

    for (i = 0; i < 4; i++) {
        val_lo <<= 5;
        val_hi <<= 5;
        val_lo |= ggCharToInt(gg[i]);
        val_hi |= ggCharToInt(gg[i + 4]);

    }

    sortGGBits(val_hi, val_lo, addr, data);
}
