/* 
 * File:   rom.h
 * Author: krik
 *
 * Created on 30  2011 ., 12:47
 */

#ifndef _ROM_H
#define	_ROM_H

#include "types.h"
#include "fat.h"
#include "os.h"

#define MKEY_JAP_NTSC 0
#define MKEY_JAP_PAL 1
#define MKEY_US_NTSC 2
#define MKEY_EU_PAL 3
#define MKEY_OFF 4


//extern RomConfig *rom_cfg;

u16 romGenerateConfig(FatFullRecord *rec, RomConfig *cfg);
void romInitAndStart();

u16 romSaveSram(u16 cd_mode);
u16 romLoadSram(u16 cd_mode);
u16 romLoadConfig();
u16 romSaveConfig();
u16 romRunNativeBios();
u16 romGetRegion(u8 *rom_hdr);
#endif	/* _ROM_H */

