

#include "string.h"

u16 strCopy(u8 *src, u8 *dst) {

    u16 i = 0;
    for (i = 0; *src != 0; i++)*dst++ = *src++;
    *dst = 0;
    return i;
}

u16 strLen(u8 *str) {

    u16 i;
    for (i = 0; *str != 0; i++)*str++;
    return i;
}

u16 strFindIdx(u8 *target, u8 *str) {

    u16 targ_len = strLen(target);
    u16 idx;
    u16 eq_len;

    eq_len = 0;
    for (idx = 0; eq_len < targ_len; idx++) {

        if (*str == 0)return 255;
        if (*str++ == target[eq_len]) {
            eq_len++;
        } else {
            eq_len = 0;
        }
    }

    if (eq_len != targ_len)return 255;
    return idx - targ_len;
}

u16 strContain(u8 *target, u8 *str) {

    u16 targ_len = strLen(target);
    u16 eq_len;


    for (eq_len = 0; eq_len < targ_len;) {

        if (*str == 0)return 0;
        if (*str++ == target[eq_len]) {
            eq_len++;
        } else {
            eq_len = 0;
        }
    }

    if (eq_len != targ_len)return 0;
    return 1;

}

u16 strEq(u8 *str1, u8 *str2) {

    u8 s1;
    u8 s2;

    for (;;) {
        s1 = *str1++;
        s2 = *str2++;
        if (s1 >= 'a' && s1 <= 'z')s1 -= 0x20;
        if (s2 >= 'a' && s2 <= 'z')s2 -= 0x20;

        if (s1 != s2) return 0;

        if (*str1 == 0 && *str2 == 0)return 1;
    }
}

u16 strEqL(u8 *str1, u8 *str2, u8 len) {

    u8 s1;
    u8 s2;
    while (len--) {

        s1 = *str1++;
        s2 = *str2++;
        if (s1 >= 'a' && s1 <= 'z')s1 -= 0x20;
        if (s2 >= 'a' && s2 <= 'z')s2 -= 0x20;

        if (s1 != s2) return 0;
    }

    return 1;
}
