/*
 * File:   disk.h
 * Author: krik
 *
 * Created on 22  2011 ., 0:05
 */

#ifndef _DISK_H
#define	_DISK_H

#include "types.h"
#include "errors.h"

#define DISK_SD 0
#define DISK_MSD 1

u8 diskRead(u32 saddr, void *buff, u16 slen);
u8 diskReadSector(u32 saddr, void *dat);
u8 diskWrite(u32 saddr, u8 *buff, u16 slen);
u8 diskWriteSector(u32 saddr, u8 *buff);
u8 diskInit();
void diskSelect(u8 disk);
u16 diskGetCurrent();
u8 diskOpenRead(u32 saddr);
void diskCloseRW();


#endif	/* _DISK_H */

