/*
 * File:   errors.h
 * Author: krik
 *
 * Created on 30  2011 ., 7:24
 */

#ifndef _ERRORS_H
#define	_ERRORS_H

#define MEM_ERR_SPI_RD_TIMEOUT 120

#define ERR_FILE_TOO_BIG 140
#define ERR_WRON_OS_SIZE 142
#define ERR_OS_VERIFY 143
#define ERR_OS_VERIFY2 144
#define ERR_BAD_DMA_ADDRESS 145
#define ERR_MUST_NOT_RET 146
#define ERR_WRONG_SND_CMD 147
#define ERR_PLAY_LIST 148

//100 - 119 fat errors
#define FAT_ERR_NOT_EXIST 100
#define FAT_ERR_EXIST 101
#define FAT_ERR_NAME 102
#define FAT_ERR_OUT_OF_FILE 103
#define FAT_ERR_BAD_BASE_CLUSTER 104;
#define FAT_ERR_NO_FRE_SPACE 105
#define FAT_ERR_NOT_FILE 106
#define FAT_ERR_FILE_MODE 107
#define FAT_ERR_ROT_OVERFLOW 108 
#define FAT_ERR_OUT_OF_TABLE 109
#define FAT_ERR_INIT 110
#define FAT_LFN_BUFF_OVERFLOW 111
#define FAT_DISK_NOT_READY 112
#define FAT_ERR_SIZE 113
#define FAT_ERR_RESIZE 114


//50
#define DISK_ERR_INIT 50
#define DISK_ERR_RD1 62
#define DISK_ERR_RD2 63

#define DISK_ERR_WR1 64
#define DISK_ERR_WR2 65
#define DISK_ERR_WR3 66
#define DISK_ERR_WR4 67
#define DISK_ERR_WR5 68


#define NET_ERROR_RESP 20

#define NET_ERROR_SOPEN1 21
#define NET_ERROR_SOPEN2 22
#define NET_ERROR_SOPEN3 23
#define NET_ERROR_SOPEN4 24
#define NET_ERROR_SOPEN5 25
#define NET_ERROR_SOPEN6 25

#define NET_ERROR_RESP_TOUT 30
#define NET_ERROR_CLOSE1 31
#define NET_ERROR_CLOSE2 32
#define NET_ERROR_CLOSE3 33
#define NET_ERROR_CLOSE4 34



#endif	/* _ERRORS_H */

