
#include "sega.h"
#include "fat.h"
#include "everdrive.h"
#include "graphics.h"
#include "mem.h"
#include "gui.h"


#define MENU_ITEMS 21
#define MAX_VIS_NAME_LEN 34
u8 cy;
u16 current_page;

u16 drawDir(u8 x, u8 y, u16 selectror, u8 items);
void fileBrowserClenText();
FatFullRecord browser_records[MENU_ITEMS];

u8 dir_name_begin[4];

u8 selectFile(FatFullRecord **rec, u16 *cmd, u16 init) {

    u8 resp = 0;
    static u16 selector;
    static u16 dir_stack_ptr;
    static u32 dir_stack[64];
    static u16 sel_stack[64];

    u16 key_friz = 0;
    s16 item;
    s16 page;
    s16 page_items;
    u16 joy_val;


    u16 pages;
    cy = 2;
    *cmd = 0;



    *rec = 0;

    while (joy != 0);


    if (init) {
        gSelectPlan(APLAN);
        gCleanPlan(1, 1);
        current_page = 1;
        selector = 0;
        dir_stack_ptr = 0;
        resp = fatLoadDir(0);
        if (resp)return resp;


        gSelectPlan(BPLAN);
        gSelectPalette(0);
        gFillRect(2, 0, 1, 40, 27);
        gFillRect(1, 0, 1, 40, 1);
        gFillRect(1, 0, 25, 40, 3);
        gSelectPlan(APLAN);

        gCleanPlan(1, 0);
    } else {
        gSelectPalette(0);
        gSelectPlan(APLAN);
    }

    cy = 1;



    for (;;) {
        pages = dir->size / MENU_ITEMS;
        if (dir->size % MENU_ITEMS != 0)pages++;
        //VDP_fillTileRect(BPLAN, 2, 0, 25, 40, 2);
        //gCleanPlan(0, 1);

        resp = drawDir(1, 1, selector, MENU_ITEMS);
        if (resp)return resp;
        /*
        gDrawString("spd: ", 1, 1);
        gAppendNum(REG_SPD & 0xff);
        gAppendString(" : ");
        gAppendNum(REG_SPD >> 8);*/



        while (joy != 0 && key_friz < 30) {
            VDP_waitVSync();
            key_friz++;
        };
        while (joy != 0) {
            VDP_waitVSync();
            key_friz++;
            if (key_friz % 3 != 0)continue;
            break;
        }
        while (joy == 0)key_friz = 0;

        joy_val = joy;


        if ((joy_val & BUTTON_A) && dir->s_records[selector]->is_dir && dir->size > 0) {


            current_page = 0xffff;
            //VDP_fillTileRect(APLAN, 0, 0, 0, 40, 25);
            fileBrowserClenText();
            dir_stack[dir_stack_ptr] = dir->entry_cluster;
            sel_stack[dir_stack_ptr] = selector;
            dir_stack_ptr++;
            //resp = fatLoadDir(dir->s_records[selector]->entry_cluster);
            memcopy(browser_records[selector % MENU_ITEMS].name, dir_name_begin, 4);
            resp = fatLoadDir(browser_records[selector % MENU_ITEMS].entry_cluster);

            selector = 0;
            if (resp)return resp;
            key_friz = 0;
            continue;
        }


        if ((joy_val & BUTTON_START)) {
            *cmd = SEL_CMD_START_OLD;
            return 0;
        }


        if ((joy_val & BUTTON_C)) {

            *cmd = SEL_CMD_MENU;
            return 0;
        }

        if ((joy_val & BUTTON_A) && !dir->s_records[selector]->is_dir && dir->size > 0) {

            *cmd = SEL_CMD_FILE_MENU;
            //*rec = dir->s_records[selector];
            *rec = &browser_records[selector % MENU_ITEMS];
            return 0;
        }

        if ((joy_val & BUTTON_B && dir_stack_ptr == 0)) {
            continue;
        }

        if ((joy_val & BUTTON_B) && dir_stack_ptr != 0) {

            current_page = 0xffff;
            fileBrowserClenText();


            dir_stack[dir_stack_ptr] = dir->entry_cluster;
            dir_stack_ptr--;
            resp = fatLoadDir(dir_stack[dir_stack_ptr]);
            selector = sel_stack[dir_stack_ptr];

            /*
            for (i = 0; i < dir->size; i++) {
                if (dir->s_records[i]->entry_cluster == dir_stack[dir_stack_ptr + 1]) {
                    selector = i;
                    break;
                }
            }*/
            if (resp)return resp;

            key_friz = 0;
            continue;
        }



        if ((joy_val & BUTTON_UP)) {

            item = selector % MENU_ITEMS;
            page = selector / MENU_ITEMS;
            page_items = dir->size - page * MENU_ITEMS;
            if (page_items > MENU_ITEMS)page_items = MENU_ITEMS;
            item--;
            if (item < 0)item = page_items - 1;
            selector = page * MENU_ITEMS + item;

            continue;
        }

        if ((joy_val & BUTTON_DOWN)) {

            item = selector % MENU_ITEMS;
            page = selector / MENU_ITEMS;
            page_items = dir->size - page * MENU_ITEMS;
            if (page_items > MENU_ITEMS)page_items = MENU_ITEMS;
            item++;
            item %= page_items;
            selector = page * MENU_ITEMS + item;

            continue;
        }

        if ((joy_val & BUTTON_RIGHT) && dir->size > MENU_ITEMS) {

            item = selector % MENU_ITEMS;
            page = selector / MENU_ITEMS;
            page++;
            if (page * MENU_ITEMS >= dir->size) {
                page = 0;
            }

            selector = page * MENU_ITEMS + item;
            if (selector >= dir->size)selector = dir->size - 1;
            key_friz = 0;
            VDP_waitVSync();
            //VDP_fillTileRect(APLAN, 0, 0, 0, 40, 28);
            fileBrowserClenText();
            continue;
        }

        if ((joy_val & BUTTON_LEFT) && dir->size > MENU_ITEMS) {

            item = selector % MENU_ITEMS;
            page = selector / MENU_ITEMS;
            page--;
            if (page < 0) {
                page = dir->size / MENU_ITEMS - 1;
                if (dir->size % MENU_ITEMS != 0)page++;
            }

            selector = page * MENU_ITEMS + item;
            if (selector >= dir->size)selector = dir->size - 1;
            key_friz = 0;
            VDP_waitVSync();
            //VDP_fillTileRect(APLAN, 0, 0, 0, 40, 28);
            fileBrowserClenText();
            continue;
        }
    }


    return 0;
}


//u8 STR_intToDecString(u32 val, u8 *str);

//u8 name_buff[MENU_ITEMS * 40];

u16 drawDir(u8 x, u8 y, u16 selectror, u8 items) {


    u16 resp;
    u8 i;
    u16 base;
    u16 page = selectror / items;
    //u16 offset = page * items;
    selectror %= items;
    FatRecord **rec = &dir->s_records[page * items];
    u16 item_idx = page * items;
    u8 name_part[40];


    gLockRepaint(1);
    y = 3;
    gCleanPlan(1, 0);

    if (page != current_page) {
        for (i = 0; (i < MENU_ITEMS) && (i + item_idx < dir->size); i++) {
            resp = fatGetFullRecord(rec[i], &browser_records[i]);
            if (resp)return resp;
        }
    }



    u16 page_total = dir->size % items == 0 ? dir->size / items : dir->size / items + 1;
    //for(i = 0;i < )
    gSelectPalette(0);
    gDrawString("Page: ", 1, 1);
    gAppendNum(page + 1);
    gAppendString(" of ");
    gAppendNum(page_total);


    for (i = 0; i < items && item_idx < dir->size; i++) {

        //record_idx = dir->dir->sort_records[offset + i];
        //VDP_fillTileRect(APLAN, 0, 0, y, 40, 1);
        base = TILE_ATTR(1, 0, 0, 0);
        if (selectror == i) {
            base = 0;
        } else if (browser_records[i].is_dir) {
            base = TILE_ATTR(2, 0, 0, 0);
        }

        item_idx++;

        //memcopy(rec[i]->name, str_buff, str_max_len);
        /*
        str_ptr = &name_buff[i * 40];
        if (page != current_page)fatGetRecordName(rec[i], str_ptr, MAX_VIS_NAME_LEN);
        str_ptr[MAX_VIS_NAME_LEN] = 0;*/

        if (browser_records[i].is_dir) {
            if (selectror == i) {
                gSelectPalette(2);
            } else {
                gSelectPalette(1);
            }
            gDrawString("DIR", 36, y);

        } else {
            if (selectror == i) {
                gSelectPalette(2);
            } else {
                gSelectPalette(0);
            }
            if (browser_records[i].size < 0x100000) {
                gDrawNum(browser_records[i].size >> 10, 36, y);
                gAppendString("K");
            } else {
                gDrawNum(browser_records[i].size >> 20, 36, y);
                gAppendString("M");
            }


        }


        gDrawStringMaxLen(browser_records[i].name, x + 0, y, MAX_VIS_NAME_LEN);
        //gDrawString(rec[i]->name_begin, x + 0, y);
        y++;
    }

    if (dir->size > 0) {
        // fatGetRecordName(rec[selectror], full_name, 0);
        gSelectPalette(0);
        name_part[38] = 0;
        memcopy(browser_records[selectror].name, name_part, 38);
        gDrawString(name_part, 1, 25);
        for (i = 0; browser_records[selectror].name[i] != 0; i++);
        if (i > 38) {
            memcopy(&browser_records[selectror].name[38], name_part, 38);
            gDrawString(name_part, 1, 26);
        }
    }


    current_page = page;
    gLockRepaint(0);

    return 0;
}

void fileBrowserClenText() {
    gSelectPlan(APLAN);
    gFillRect(0, 0, 3, 40, MENU_ITEMS);
}
