/*
 * File:   usb.h
 * Author: krik
 *
 * Created on 23  2011 ., 12:46
 */

#ifndef _USB_H
#define	_USB_H

#include "types.h"

u8 usbReadByte();
u16 usbReadWord();
void usbWriteByte(u8 dat);
u8 usbRdReady();
u8 usbWrReady();
u8 usbReadDma(u16 *dst, u16 slen);
void usbListener();
void usbListenerOff();
void usbListenerOn();

u32 usbWrite(void *data, u32 len, u32 timeout);
u32 usbRead(void *data, u32 len, u32 timeout);

#endif	/* _USB_H */

